登录
首页 >  文章 >  前端

LeetCode 冥想:断词

来源:dev.to

时间:2024-12-06 14:37:02 475浏览 收藏

目前golang学习网上已经有很多关于文章的文章了,自己在初次阅读这些文章中,也见识到了很多学习思路;那么本文《LeetCode 冥想:断词》,也希望能帮助到大家,如果阅读完后真的对你学习文章有帮助,欢迎动动手指,评论留言并分享~

LeetCode 冥想:断词

此问题的描述是:

给定一个字符串 s 和一个字符串字典 worddict,如果 s 可以分割成一个或多个字典单词的空格分隔序列,则返回 true。

注意词典中的同一个单词可能会在分词中重复使用多次。

例如:

input: s = "leetcode", worddict = ["leet", "code"]
output: true

explanation: return true because "leetcode" can be segmented as "leet code".

或者:

input: s = "applepenapple", worddict = ["apple", "pen"]
output: true

explanation: return true because "applepenapple" can be segmented as "apple pen apple".
note that you are allowed to reuse a dictionary word.

或者:

input: s = "catsandog", worddict = ["cats", "dog", "sand", "and", "cat"]
output: false

此外,我们的约束表明worddict 的所有字符串都是**唯一**,并且:

  • 1 <= s.length <= 300
  • 1 <= worddict.length <= 1000
  • 1 <= worddict[i].length <= 20
  • s 和 worddict[i] 仅由小写英文字母组成。

继续动态编程解决方案,我们可以看看一种流行的自下而上的方法,我们构建一个 dp 数组来跟踪是否可以在每个索引处将 s 分解为 worddict 中的单词。

每个索引 dp 数组中将指示是否可以将整个字符串分解为从索引开始的单词 .

note
dp needs to be of size s.length 1 to hold the edge case of an empty string, in other words, when we're out of bounds.

让我们用最初的错误值来创建它:

let dp = array.from({ length: s.length + 1 }, () => false); // +1 for the base case, out of bounds

最后一个索引是空字符串,可以认为它是可破坏的,或者换句话说,有效的:

dp[s.length] = true; // base case

向后看,对于 s 的每个索引,我们可以检查从该索引开始是否可以到达 worddict 中的任何单词:

for (let i = s.length - 1; i >= 0; i--) {
  for (const word of worddict) {
    /* ... */
  }
}

如果我们仍在 s (i word.length <= s.length) 的范围内并且找到了单词 (s.slice(i, i word.length) === word),我们'将该槽标记为我们可以打破字符串的“下一个位置”的真值,这将是 i word.length:

for (let i = s.length - 1; i >= 0; i--) {
  for (const word of worddict) {
    if (i + word.length <= s.length && s.slice(i, i + word.length) === word) {
      dp[i] = dp[i + word.length];
    }
    /* ... */
  }
}

如果我们可以将其分解为worddict中的任何单词,我们就不必继续查看其他单词,因此我们可以跳出循环:

for (let i = s.length - 1; i >= 0; i--) {
  for (const word of worddict) {
    if (i + word.length <= s.length && s.slice(i, i + word.length) === word) {
      dp[i] = dp[i + word.length];
    }
    if (dp[i]) {
      break;
    }
  }
}

最后,我们返回 dp[0] - 如果整个字符串可以分解为 worddict 中的单词,则其值将存储 true,否则为 false:

function wordbreak(s: string, worddict: string[]): boolean {
  /* ... */
  return dp[0];
}

而且,这是最终的解决方案:

function wordBreak(s: string, wordDict: string[]): boolean {
  let dp = Array.from({ length: s.length + 1 }, () => false); // +1 for the base case, out of bounds
  dp[s.length] = true; // base case

  for (let i = s.length - 1; i >= 0; i--) {
    for (const word of wordDict) {
      if (i + word.length <= s.length && s.slice(i, i + word.length) === word) {
        dp[i] = dp[i + word.length];
      }
      if (dp[i]) {
        break;
      }
    }
  }

  return dp[0];
}

时间和空间复杂度

时间复杂度为 o(n*m*to(n * m * t) o(n*m*t) 在哪里 nn n 是字符串 s, 是 worddict 中的单词数,并且 tt t 是 worddict 中的最大长度单词 - 因为我们有一个嵌套循环,通过切片操作遍历 worddict 中的每个单词,该切片操作使用 s 中每个字符的 word.length。

空间复杂度为 o(n)o(n) o(n) 因为我们为 s 的每个索引存储 dp 数组。


该系列中的最后一个动态规划问题将是最长递增子序列。在那之前,祝您编码愉快。

终于介绍完啦!小伙伴们,这篇关于《LeetCode 冥想:断词》的介绍应该让你收获多多了吧!欢迎大家收藏或分享给更多需要学习的朋友吧~golang学习网公众号也会发布文章相关知识,快来关注吧!

声明:本文转载于:dev.to 如有侵犯,请联系study_golang@163.com删除
相关阅读
更多>
最新阅读
更多>
课程推荐
更多>